package com.malk.ruisi.controller;

/**
 * 错误抛出与拦截详见 CatchException
 */

import cn.hutool.core.text.UnicodeUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.malk.ruisi.service.RSService;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.server.common.McException;
import com.malk.server.common.McR;
import com.malk.server.dingtalk.DDConf;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilHttp;
import com.malk.utils.UtilServlet;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.time.LocalDateTime;
import java.time.ZoneOffset;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

@Slf4j
@RestController
@RequestMapping
public class CosController {

    @Autowired
    private RSService rsService;

    /**
     * 创建投资人用户
     */
    @PostMapping("user/sync")
    McR syncUser() {
        
        log.info("syncUser");
        rsService.syncDingTalk_exclusive();
        return McR.success();
    }

    /**
     * 重置密码流程
     */
    @PostMapping("reset")
    McR resetPwd(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("reset, {}", data);

        McException.assertParamException_Null(data, "userId", "password");
        rsService.resetPwd(data);
        return McR.success();
    }

    @PostMapping("test")
    McR test() {

        return McR.success();
    }

    /**
     * 资讯卡片
     * 1. 接口格式为 formData, 宜搭服务注册一致
     * 2. 工作台页面不支持配置参数, 需要通过接口区分
     */
    @PostMapping("portal/cw")
    List<Map> portal(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("工作台数据, {}", data);
        return rsService.getPortalList("财务专区");
    }

    @PostMapping("portal/gs")
    List<Map> portal1(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("工作台数据, {}", data);
        return rsService.getPortalList("公司头条");
    }

    @PostMapping("portal/qy")
    List<Map> portal2(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("工作台数据, {}", data);
        return rsService.getPortalList("企业文化");
    }

    @PostMapping("portal/yg")
    List<Map> portal3(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("工作台数据, {}", data);
        return rsService.getPortalList("员工自助");
    }

    @PostMapping("portal/gz")
    List<Map> portal4(HttpServletRequest request) {

        Map data = UtilServlet.getParamMap(request);
        log.info("工作台数据, {}", data);
        return rsService.getPortalList("规章制度");
    }

    @GetMapping("hzmh/byType")
    public void hzmhByType() {
        try {
            rsService.getDataList();

        } catch (Exception e) {
            // 记录错误信息
            e.printStackTrace();
        }
    }
    /// 流程分享权限 1. 发起人可操作权限 2. 配置弹出框在可编辑权限
    @PostMapping("share/record")
    McR shareRecord(@RequestParam String processInstanceId, @RequestBody Map data) {

        log.info("流程分享权限, {}, {}", processInstanceId, data);
        rsService.shareRecord(processInstanceId, data);
        return McR.success();
    }

    /// 获取审批节点 1. 未到达审批前权限问题, 2. 抄送人\审批人不能评论权限问题, 3. 或签非审批操作人无打印权限问题
    @PostMapping("approval/record")
    McR approvalRecord(@RequestParam String processInstanceId, @RequestBody Map data) {

        log.info("获取审批节点, {}, {}", processInstanceId, data);

        Map map = rsService.approvalRecord(processInstanceId, data);
        return McR.success(map);
    }
    @GetMapping("/txt")
    public String txt() throws Exception {
        return getAccessToken_RS();
    }
    @Autowired
    private YDClient ydClient;
    @Autowired
    private YDConf ydConf;
    @Autowired
    private DDConf ddConf;
    @PostMapping("/restPassword")
    public McR restPassword(@RequestBody Map map) throws Exception {
        String formInstanceId = String.valueOf(map.get("formInstanceId"));
        //根据实例ID获取表单数据
        Map data = (Map) ydClient.queryData(YDParam.builder().formInstId(formInstanceId)
                .appType(ydConf.getAppType()).systemToken(ydConf.getSystemToken())
                .userId(ddConf.getOperator()).build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
        log.info("data:{}", data);
        String email = data.get("textField_m33wwc3s").toString();
//        String email = "matthewsun@rdchina.net";
        Map param = new HashMap();
        param.put("Authorization", "Bearer "+getAccessToken_RS());
        param.put("Content-Type", "application/json");
        Map body = new HashMap();
        body.put("password", "1234abcdW@");
        body.put("forceChangePasswordNextSignIn", true);

       UtilHttp.doPost("https://alimail-cn.aliyuncs.com/v2/users/"+email+"/resetPassword",  param, null,body );

        return McR.success();
    }
    public String getAccessToken_RS() throws Exception {
        Map param = new HashMap();
        param.put("grant_type", "client_credentials");
        param.put("client_id", "smd83Uj6Waoeijfc");
        param.put("client_secret", "8qlBbswcfEbNZrANdSYCvZ6PQJXMHL9ZN4ygj2H9RyhO7T2bLG9k287P9NXJwjH5");
        JSONObject jsonObject = sendData(param, true, true, null);
        String access_token = jsonObject.getString("access_token");
        return access_token;
    }


    public JSONObject sendData(Map param, Boolean isPost, Boolean isBody, String url) throws Exception {
        JSONObject resultObj = null;
        try {
            HttpRequest httpRequest = createRequest(param, isPost, isBody, url);
            HttpResponse httpResponse = httpRequest.execute();
            log.info("httpResponse:{}", httpResponse);
            String result = httpResponse.body();
            if (ObjectUtil.isNull(result)) {
                throw new Exception("接口返回值为空");
            }
            result = UnicodeUtil.toString(result);
            log.info("result:{}", result);
            resultObj = JSONObject.parseObject(result);
        } catch (Exception e) {
            e.printStackTrace();
            throw new Exception("请求阿里邮箱接口异常");
        }
        return resultObj;
    }
    public HttpRequest createRequest(Map param, Boolean isPost, Boolean isBody, String url) throws Exception {
        String str = param == null || param.isEmpty() ? "" : JSONObject.toJSONString(param);
        log.info("请求地址：{}", url);
        log.info("请求参数：{}", str);
        HttpRequest httpRequest = null;
        if (isPost) {
            if (isBody) {
                httpRequest = HttpUtil.createPost("https://alimail-cn.aliyuncs.com/oauth2/v2.0/token").form(param).header("Content-Type", "application/x-www-form-urlencoded;charset=UTF-8");
            } else {
                httpRequest = HttpUtil.createPost("https://alimail-cn.aliyuncs.com/oauth2/v2.0/token").body(str).header("Content-Type", "application/json");
            }
        } else {
            httpRequest = HttpUtil.createGet("https://alimail-cn.aliyuncs.com/oauth2/v2.0/token").form(param);
        }
        String nowTimestamp = String.valueOf(LocalDateTime.now().toInstant(ZoneOffset.of("+8")).toEpochMilli());
        String nonce = UUID.randomUUID().toString();
        log.debug("nowTimestamp:{},nonce:{}", nowTimestamp, nonce);
//        httpRequest = httpRequest
//                .header("x-qys-accesstoken", QYS_API_TOKEN)
//                .header("x-qys-timestamp", nowTimestamp)
//                .header("x-qys-nonce", nonce)
//                .header("x-qys-signature", SecureUtil.md5(QYS_API_TOKEN + QYS_API_SECRET + nowTimestamp + nonce));
        return httpRequest;
    }
}
