package com.malk.ruisi.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.malk.ruisi.service.RsQysService;
import com.malk.ruisi.service.dingshiqi;
import com.malk.server.common.McR;
import com.malk.service.aliwork.YDClient;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.*;

import java.time.LocalDateTime;
import java.util.Map;

@RestController
@Slf4j
@RequestMapping("/qys")
public class RsQysController {
    @Autowired
    private RsQysService rsQysService;

    @Autowired
    private dingshiqi ds;
    /* 契约锁回调密钥 */
    @PostMapping("/qysDsrw")
    public McR qysDsrw(@RequestBody  Map data) throws Exception {
        String DAFL = String.valueOf(data.get("DAFL"));
        if ("YWFL".equals(DAFL)){
            try {
                System.out.println("开始上传业务ID");
                System.out.println(LocalDateTime.now());
                ds.getYWFLid();
                System.out.println("结束业务ID");
            } catch (Exception e) {
                // 记录错误信息
                e.printStackTrace();
            }
        }else if ("YZWL".equals(DAFL)){
            try {
                System.out.println("开始上传物理印章ID");
                System.out.println(LocalDateTime.now());
                ds.getYWFLid1();
                System.out.println("结束物理印章ID");
            } catch (Exception e) {
                // 记录错误信息
                e.printStackTrace();
            }
        } else if ("YZDZ".equals(DAFL)){
            try {
                System.out.println("开始上传电子印章ID");
                System.out.println(LocalDateTime.now());
                ds.getYWFLid2();
                System.out.println("结束电子印章ID");
            } catch (Exception e) {
                // 记录错误信息
                e.printStackTrace();
            }
        }
        return McR.success();
    }

    /***
     * 第一步
     * 根据文件类型创建合同文档
     * @param
     * @return
     */

    @PostMapping("/createbyfile")
    public McR createByFile(@RequestBody JSONObject param) throws Exception {
        log.info("createbyfile:{}", JSON.toJSONString(param));
        return rsQysService.createByFile(param);
    }
    /***
     * 创建校区劳动新签合同
     * @param
     * @return
     */
    @PostMapping("/createContract")
    public McR createContract(@RequestBody JSONObject param) throws Exception {
        log.info("createContract:{}", JSON.toJSONString(param));
        return rsQysService.createContract(param);
    }

    /***
     * 创建新签合同
     * @param
     * @return
     */
    @PostMapping("/createReContract")
    public McR createReContract(@RequestBody JSONObject param) throws Exception {
        log.info("createReContract:{}", JSON.toJSONString(param));
        return rsQysService.createReContract(param);
    }
    /***
     * 预签署  可重复获取
     */
    @PostMapping("/appointurl")
    public McR appointurl(String contractId) throws Exception {
        log.info("appointurl：{}",contractId);
//            String contractId=String.valueOf(param.getString("contractId"));
//            return McR.success(contractId);
        return rsQysService.appointurl(contractId);
    }

    /***
     * 浏览合同
     * @param
     * @return
     */
    @PostMapping("/viewurl")
    public McR viewurl(String contractId,String pageType) throws Exception {
        log.info("viewurl：{},{}",contractId,pageType);
        return rsQysService.viewurl(contractId,pageType);
    }


    /***
     * 签署合同
     * @param
     * @return
     */
    @PostMapping("/audit")
    public McR audit(String contractId) throws Exception {
        log.info("contractId：{}",contractId);
        return rsQysService.audit(contractId);
    }
//    /***
//     * 预签署  可重复获取
//     * @param
//     * @return
//     */
//    @PostMapping("/downloadappointurl")
//    public McR downloadappointurl(String contractId) throws Exception {
//        log.info("appointurl：{}",contractId);
////            String contractId=String.valueOf(param.getString("contractId"));
////            return McR.success(contractId);
//        return rsQysService.appointurldownload(contractId);
//    }
//    /***
//     * 第二步
//     * 发起合同、完成发起方签署
//     * @param
//     * @return
//     */
//    @PostMapping("/send")
//    public McR sendContract(String contractId) throws Exception {
//        log.info("进入 step two 接口,参数：{}",contractId);
//        return rsQysService.sendContract(contractId);
//    }
    /***
     * 授权物理印章码
     */
    @PostMapping("/apply")
    public McR apply(@RequestBody JSONObject param) throws Exception {
        log.info("进入 apply 接口,参数：{}",param);
        return rsQysService.apply(param);
    }

    /***
     * 合同签署页面
     */
    @PostMapping("/signurl")
    public McR signurl(@RequestBody JSONObject param) throws Exception {
        log.info("进入 apply 接口,参数：{}",param);
        return rsQysService.signurl(param);
    }

    @Autowired
    private dingshiqi timer;

    /**
     * 同步同步契约锁档案
     */
    @GetMapping("sync-qys")
    public McR syncQys(@RequestParam String type) {

        timer.syncCommon(type);
        return McR.success();
    }

}
